// Copyright 2008-2018 Yolo Technologies, Inc. All Rights Reserved. https://www.comblockengine.com


#ifndef KBENGINE_DEF_COMMON_H
#define KBENGINE_DEF_COMMON_H

#include "common/common.h"
#if KBE_PLATFORM == PLATFORM_WIN32
#pragma warning (disable : 4910)
#pragma warning (disable : 4251)
#endif


namespace KBEngine{

/** entityݴԱ */
enum EntityDataFlags
{
	ED_FLAG_UNKOWN													= 0x00000000, // δ
	ED_FLAG_CELL_PUBLIC												= 0x00000001, // cell㲥
	ED_FLAG_CELL_PRIVATE											= 0x00000002, // ǰcell
	ED_FLAG_ALL_CLIENTS												= 0x00000004, // cell㲥пͻ
	ED_FLAG_CELL_PUBLIC_AND_OWN										= 0x00000008, // cell㲥ԼĿͻ
	ED_FLAG_OWN_CLIENT												= 0x00000010, // ǰcellͿͻ
	ED_FLAG_BASE_AND_CLIENT											= 0x00000020, // baseͿͻ
	ED_FLAG_BASE													= 0x00000040, // ǰbase
	ED_FLAG_OTHER_CLIENTS											= 0x00000080, // cell㲥ͻ
};

std::string entityDataFlagsToString(uint32 flags);
EntityDataFlags stringToEntityDataFlags(const std::string& strFlags);

#define ED_FLAG_ALL  ED_FLAG_CELL_PUBLIC | ED_FLAG_CELL_PRIVATE | ED_FLAG_ALL_CLIENTS \
	| ED_FLAG_CELL_PUBLIC_AND_OWN | ED_FLAG_OWN_CLIENT |	\
	ED_FLAG_BASE_AND_CLIENT | ED_FLAG_BASE | ED_FLAG_OTHER_CLIENTS

/** ൱ڶentityݴһĶ */
enum EntityDataFlagRelation
{
	// baseappйϵı־
	ENTITY_BASE_DATA_FLAGS											= ED_FLAG_BASE | ED_FLAG_BASE_AND_CLIENT,
	// cellappйϵı־
	ENTITY_CELL_DATA_FLAGS											= ED_FLAG_CELL_PUBLIC | ED_FLAG_CELL_PRIVATE | ED_FLAG_ALL_CLIENTS | ED_FLAG_CELL_PUBLIC_AND_OWN | ED_FLAG_OTHER_CLIENTS | ED_FLAG_OWN_CLIENT,
	// clientйϵı־
	ENTITY_CLIENT_DATA_FLAGS										= ED_FLAG_BASE_AND_CLIENT | ED_FLAG_ALL_CLIENTS | ED_FLAG_CELL_PUBLIC_AND_OWN | ED_FLAG_OTHER_CLIENTS | ED_FLAG_OWN_CLIENT,
	// Ҫ㲥cellappı־
	ENTITY_BROADCAST_CELL_FLAGS										= ED_FLAG_CELL_PUBLIC | ED_FLAG_ALL_CLIENTS | ED_FLAG_CELL_PUBLIC_AND_OWN | ED_FLAG_OTHER_CLIENTS,
	// Ҫ㲥ͻ(Լ)ı־
	ENTITY_BROADCAST_OTHER_CLIENT_FLAGS								= ED_FLAG_OTHER_CLIENTS | ED_FLAG_ALL_CLIENTS,
	// Ҫ㲥ԼĿͻ˵ı־
	ENTITY_BROADCAST_OWN_CLIENT_FLAGS								= ED_FLAG_ALL_CLIENTS | ED_FLAG_CELL_PUBLIC_AND_OWN | ED_FLAG_OWN_CLIENT | ED_FLAG_BASE_AND_CLIENT,
	// baseappͻйصı־
	ENTITY_BASEAPP_ANDA_CLIENT_DATA_FLAGS							= ED_FLAG_BASE_AND_CLIENT,
	// cellappͻйصı־
	ENTITY_CELLAPP_ANDA_CLIENT_DATA_FLAGS							= ED_FLAG_ALL_CLIENTS | ED_FLAG_CELL_PUBLIC_AND_OWN | ED_FLAG_OTHER_CLIENTS | ED_FLAG_OWN_CLIENT,
};

/** entityCallӦӳ䣬  ϸƥENTITYCALL_TYPEֵ */
const COMPONENT_TYPE ENTITYCALL_COMPONENT_TYPE_MAPPING[] = 
{
	CELLAPP_TYPE,
	BASEAPP_TYPE,
	CLIENT_TYPE,
	BASEAPP_TYPE,
	CELLAPP_TYPE,
	CELLAPP_TYPE,
	BASEAPP_TYPE,
};

/** Եlod㲥ΧĶ */
typedef uint8 DETAIL_TYPE;
#define DETAIL_LEVEL_NEAR													0	// lod𣺽						
#define DETAIL_LEVEL_MEDIUM													1	// lod
#define DETAIL_LEVEL_FAR													2	// lodԶ	

typedef std::map<std::string, EntityDataFlags> ENTITYFLAGMAP;
extern ENTITYFLAGMAP g_entityFlagMapping;										// entity flagַӳ

// ԺͷUID
typedef uint16 ENTITY_PROPERTY_UID;
typedef uint16 ENTITY_METHOD_UID;
typedef uint16 ENTITY_SCRIPT_UID;
typedef uint16 ENTITY_COMPONENT_UID;
typedef uint16 DATATYPE_UID;
typedef uint8  DATATYPE;
typedef uint8  ENTITY_DEF_ALIASID;
typedef uint8  ENTITY_COMPONENT_ALIASID;

#define DATA_TYPE_UNKONWN				0
#define DATA_TYPE_FIXEDARRAY			1
#define DATA_TYPE_FIXEDDICT				2
#define DATA_TYPE_STRING				3
#define DATA_TYPE_DIGIT					4
#define DATA_TYPE_BLOB					5
#define DATA_TYPE_PYTHON				6
#define DATA_TYPE_VECTOR2				7
#define DATA_TYPE_VECTOR3				8
#define DATA_TYPE_VECTOR4				9
#define DATA_TYPE_UNICODE				10
#define DATA_TYPE_ENTITYCALL			11
#define DATA_TYPE_PYDICT				12
#define DATA_TYPE_PYTUPLE				13
#define DATA_TYPE_PYLIST				14
#define DATA_TYPE_ENTITY_COMPONENT		15

// entityһЩϵͳĿɱԽбԱ紫ʱб
enum ENTITY_BASE_PROPERTY_UTYPE
{
	ENTITY_BASE_PROPERTY_UTYPE_POSITION_XYZ					= 1,
	ENTITY_BASE_PROPERTY_UTYPE_DIRECTION_ROLL_PITCH_YAW		= 2,
	ENTITY_BASE_PROPERTY_UTYPE_SPACEID						= 3,
};

// entityһЩϵͳĿɱԽбԱ紫ʱб
enum ENTITY_BASE_PROPERTY_ALIASID
{
	ENTITY_BASE_PROPERTY_ALIASID_NULL						= 0,
	ENTITY_BASE_PROPERTY_ALIASID_POSITION_XYZ				= 1,
	ENTITY_BASE_PROPERTY_ALIASID_DIRECTION_ROLL_PITCH_YAW	= 2,
	ENTITY_BASE_PROPERTY_ALIASID_SPACEID					= 3,
	ENTITY_BASE_PROPERTY_ALIASID_MAX						= 4,
};

// Ƶϵͳԣdefв
const char ENTITY_LIMITED_PROPERTYS[][34] =
{
	"id",
	"position",
	"direction",
	"spaceID",
	"autoLoad",
	"cell",
	"base",
	"client",
	"cellData",
	"className",
	"component"
	"databaseID",
	"isDestroyed",
	"shouldAutoArchive",
	"shouldAutoBackup",
	"__ACCOUNT_NAME__",
	"__ACCOUNT_PASSWORD__",
	"clientAddr",
	"clientEnabled",
	"hasClient",
	"roundTripTime",
	"timeSinceHeardFromClient",
	"allClients",
	"hasWitness",
	"isWitnessed",
	"otherClients",
	"topSpeed",
	"topSpeedY",
	"interface"
	"",
};

// ý̵pythonĿ¼
std::pair<std::wstring, std::wstring> getComponentPythonPaths(COMPONENT_TYPE componentType);

}
#endif // KBENGINE_DEF_COMMON_H

